 {$INCLUDE POI_Export.config.pas}


var
    CacheName: string;      // Sbr zkracovan nzvy ke
    ThisCacheName: string;  // Jmno aktuln kee, zkrcen
    Ikony_kdes: string;     // oven adres


{Tato metoda vytvori String strukturovany jako kus GPX dokumentu}
function FormatPointLight(wLat,wLon,wTime,wName,wDesc,wSym,wType,wIco: String): String;
begin
  Result :=
  + ' <wpt lat="' + wLat + '" lon="' + wLon + '">' + CRLF
  //+ '  <time>' + wTime + '</time>' + CRLF
  + '  <name>' + CDATA(wName) + '</name>' + CRLF
  + '  <cmt></cmt>' + CRLF
  + '  <desc>' + CDATA(UtfToAscii(HtmlImg2Link(wDesc))) + '</desc>' + CRLF
  + '  <link href="file://' + Ikony_kdes + '/' + wIco + '.bmp"/>' + CRLF
 // + '  <sym>' + wSym + '</sym>' + CRLF
 // + '  <type>' + wType + '</type>' + CRLF
  + ' </wpt>' + CRLF;
end;

{Tato metoda vytvori String strukturovany jako kus GPX dokumentu
 Radky oznacene jako "lze zakomentovat" v pripade potreby zakomentujte - hned 
 na zacatku radku pred plusem}
function FormatPoint(wLat,wLon,wTime,wName,wDesc,wSym,wType,wIco: String): String;
begin
  Result :=
  + ' <wpt lat="' + wLat + '" lon="' + wLon + '">' + CRLF
  + '  <time>' + wTime + '</time>' + CRLF //lze zakomentovat
  + '  <name>' + CDATA(wName) + '</name>' + CRLF
  + '  <cmt><![CDATA[]]></cmt>' + CRLF
  + '  <desc>' + CDATA(UtfToAscii(HtmlImg2Link(wDesc))) + '</desc>' + CRLF
//  + '  <url><![CDATA[]]></url>' + CRLF //lze zakomentovat
//  + '  <urlname><![CDATA[]]></urlname>' + CRLF //lze zakomentovat
  + '  <link href="file://' + Ikony_kdes + '/' + wIco + '.bmp"/>' + CRLF
  + '  <sym>' + wSym + '</sym>' + CRLF //lze zakomentovat
  + '  <type>' + wType + '</type>' + CRLF //lze zakomentovat
  + ' </wpt>' + CRLF;
end;

{Metoda vraci otucneny text}
function Bold(text : String) : String;
begin
  Result := '<b>' + text + '</b>';
end;

{Metoda vraci obarveny text}
function Color(Text, TargetColor: String) : String;
begin
  Result := '<font color=' + TargetColor + '>' + Text + '</font>';
end;

{Metoda vraci obarveny text}
function BGColor(Text, TargetColor: String) : String;
begin
  Result := '<font bgcolor=' + TargetColor + '>' + Text + '</font>';
end;

{Metoda vraci text se zmenenou velikosti}
function Size(Text, TargetSize: String) : String;
begin
  Result := '<font size=' + TargetSize + '>' + Text + '</font>';
end;

{Metoda vraci minimum z dvou predanych hodnot}
function Minimum(a, b : Integer) : Integer;
begin
  If a < b then Result := a
  else Result := b;
end;

function Je_nase: boolean;
begin
	Result := (pos(User1, lowercase(GC.Author)) > 0) or
	          (pos(User2, lowercase(GC.Author)) > 0) or
	          (pos(User3,	lowercase(GC.Author)) > 0) or
	          (pos(User4,	lowercase(GC.Author)) > 0) or
	          (pos(User5,	lowercase(GC.Author)) > 0) or
		   GC.IsOwner or
		   GC.TagHaveCategory('Nase')
end;

Function StateSymbol(geo:Tgeo):string;
begin
  if geo.IsArchived then      Result := Sym_Archi   //Vbr sprvnho symbolu
    else if geo.IsFound then    Result := Sym_Found
    else if geo.IsDisabled then Result := Sym_Disab
    else                       Result := '';
end;

function ProcessHint(Hint:string): string;
var HintOut: string;
begin
    if HintRot = '1' then HintOut := Rot13(Hint) else HintOut := Hint;
    if HintRevers = '1' then HintOut := Reverse(HintOut);
    Result := HintOut;
end;

{Metoda zpracuje predany bod TGeo a vrati naformatovany kod GPX}
function ProcessGeo(geo: TGeo) : String;
var
  	wLat,wLon,wDate,wName,wDesc,wSym,wType,wIco,status: string;
	n : Integer;
begin
      //poskladame parametry
      wLat := geo.Lat;
      wLon := geo.Lon;
      wDate := formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', geo.Hidden);
      status := '';
        if geo.isFound then      status := status + Sym_Found;
        if geo.isArchived then   status := status + Sym_Archi
        else
        if geo.isDisabled then   status := status + Sym_Disab;
        if not (status = '') then status := status + ' ';        
      wName := UtfToAscii(geo.IDTag + ' ' + status + geo.Name);
      
      wDesc := 
        Bold(geo.CacheType) + ' Autor: ' + Bold(geo.Author) + ' dne ' + Bold(formatdatetime('dd". "mm". "yyyy', geo.Hidden)) + '<br>'
        if geo.isArchived then      wDesc := wDesc + Color(Bold('ARCHIVOVANA kes!'),TEXT_COLOR_DISABLED) + '<br>'
        else
        if geo.isDisabled then      wDesc := wDesc + Color(Bold('Docasne zruseno!'),TEXT_COLOR_DISABLED) + '<br>';
        if geo.isFound then         wDesc := wDesc + Color(Bold('Nalezl jsi dne: ' + formatdatetime('dd". "mm". "yyyy', geo.Found) +'.'),TEXT_COLOR_FOUND) + '<br>';
        wDesc := wDesc + '<br>'; 
        if geo.Size = 'Waymark' Then
        begin
          wDesc := wDesc + BgColor (Bold('WM ID:    ') + geo.ID + '<br>',TEXT_COLOR_FOUND);
        end
        else
           wDesc := wDesc + Bold('ID:    ') + geo.ID + '<br>';
        wDesc := wDesc + Bold('D / T  :  ') + geo.Difficulty + ' / ' + geo.Terrain + '<br>' +
        Bold('Velikost: ') + geo.Size + '<br>';
        if (geo.TagHaveCategory(ELEVATION_TAG))  then wDesc := wDesc + Bold('Nadmorska vyska: ') + geo.TagValues(ELEVATION_TAG) + ' m.n.m.<br>';
        if (geo.TagHaveCategory(EVALUATION_TAG)) then wDesc := wDesc + Bold('Hodnoceni: ') + geo.TagValues(EVALUATION_TAG) + '<br>';
        wDesc := wDesc + '<br>' +
        Bold('Aktualizace: ') + formatdatetime('dd". "mm". "yyyy', geo.Updated) + '<br>' +
        Bold('Posl. nalez: ') + formatdatetime('dd". "mm". "yyyy', geo.LastFound);
        if not (geo.Comment = '') then wDesc := wDesc +  + '<br><br>' + Bold('Vlastni komentar: ') + geo.Comment;
        if not (geo.Hint = '') then wDesc := wDesc +  + '<br><br>' + Bold('Hint: ') + ProcessHint(geo.Hint);
        if ((EXPORT_LISTING = '1') AND (geo.HaveListing)) then wDesc := wDesc + '<br><br>' + Bold('Listing:') + '<br>' + geo.ShortDescription + '<br>' + geo.LongDescription;
        if (EXPORT_LOGS_MAXCOUNT <> '0') then
        begin
          if geo.Logs.count > 0 then 
          begin
            wDesc := wDesc + '<br><br>' + Bold('Logy:') + '<br>'
          
            for n := 0 to Minimum(geo.Logs.count - 1,StrToInt(EXPORT_LOGS_MAXCOUNT)-1) do
            begin
              wDesc := wDesc + Bold(geo.Logs[n].Finder + ' (' + formatdatetime('dd". "mm". "yyyy', geo.Logs[n].Date) + ', ' + geo.Logs[n].LogType + '):') + '<br>';
              wDesc := wDesc + geo.Logs[n].Text + '<br><br>';
            end;
          end;
        end;


      wSym := 'Geocache';
	    if geo.IsFound then wSym := 'Geocache Found';
      wType := 'Geocache|' + geo.CacheType;
      if Je_nase then
        begin							//  Vlastn keka jakhokoli typu
           wIco := 'Cache_MY';
	  end
       else
        if geo.IsFound then
          begin							// Jakkoli nalezen ke
            wIco := 'Caches_found';
          end
    	  else
    	    if geo.Size = 'Waymark' Then
             begin
                wIco := 'Cache_' + ReplaceString(geo.CacheType, ' ', '_');
             end
             else
          begin							// Nenalezen kee - kad svou ikonu
            wIco := 'Cache_' + geo.TypeID;
            if geo.IsArchived then wIco := wIco + Append_Archive;
            if geo.IsDisabled then wIco := wIco + Append_Disable;
	  end;
    
      //potom nechame logiku bod zpracovat
      Result := FormatPoint(wLat, wLon, wDate, wName, wDesc, wSym, wType, wIco);
end;

{Metoda zpracuje predany bod TWpt a vrati naformatovany kod GPX}
function ProcessWpt(wpt : TWpt) : String;
var
    geo : TGeo;
    wLat,wLon,wDate,wName,wDesc,wSym,wType,wIco,status: string;
begin 
      //ziskame referenci na materskou kesku
      geo := wpt.ParentGeo;
      //poskladame parametry
      wLat := wpt.Lat;
      wLon := wpt.Lon;
      wDate := formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', geo.Hidden);
      status := '';
        if geo.isFound then      status := status + Sym_Found;
        if geo.isArchived then   status := status + Sym_Archi
        else
        if geo.isDisabled then   status := status + Sym_Disab;
        if not (status = '') then status := status + ' ';        
      wName := geo.IDTag + '/' + wpt.PrefixID + ' ' + status + UtfToAscii(geo.Name) + ' (' + UtfToAscii(wpt.Name) + ')';
        if geo.isArchived then      wDesc := wDesc + Color(Bold('ARCHIVOVANO!'),TEXT_COLOR_DISABLED) + '<br>'
        else
        if geo.isDisabled then      wDesc := wDesc + Color(Bold('Docasne zruseno!'),TEXT_COLOR_DISABLED) + '<br>';
        if geo.isFound then         wDesc := wDesc + Color(Bold('Tuto kes jsi nasel dne: ' + formatdatetime('dd". "mm". "yyyy', geo.Found) +'.'),TEXT_COLOR_FOUND) + '<br>';
        wDesc := wDesc + '<br>' +
        Bold('ID: ') +  wpt.ID  +' (' + geo.ID + ')' +'<br>' +
        Bold('Type: ') + wpt.WptType + '<br>';
        if (wpt.WptType = 'Final Location') then 
        begin
          wDesc := wDesc + 
          Bold('Difficulty: ') + geo.Difficulty + '<br>' +
          Bold('Size: ') + geo.Size + '<br>';
          if not (geo.Hint = '') then wDesc := wDesc + '<br><br>' + BgColor(Bold('Hint: ') + Reverse(geo.Hint), TEXT_COLOR_FOUND);
        end;
        if not (wpt.Description = '') then wDesc := wDesc + '<br>' + Bold('Description: ') + wpt.Description + '<br>';
        if not (wpt.Comment = '') then wDesc := wDesc + '<br>' + Bold('User comment: ') + wpt.Comment;
        
      wSym := wpt.WptType;
      wType := 'Waypoint|' + wpt.WptType;
      if (wpt.TypeID = 'P') then      //Export for Waypoints ... PARKING -------------------------
           begin
              wIco := 'WPT_P';
           end
      else
      if wpt.IsFinal then
      begin
        if Je_nase then
          begin							// vlastn FINAL
             wIco := 'Cache_MY';
          end
          else
             if GC.IsFound then
             begin							// ji nalezen FINAL
                wIco := 'Caches_found';
             end
             else
             begin							// znm FINALKA, vhodn k hledn
                wIco := 'Cache_TU'; // modr krabika
             end
      end
      else                          // ostatn body  
        wIco := '/WPT_' + wpt.TypeID;

      //potom nechame logiku bod zpracovat
      Result := FormatPoint(wLat, wLon, wDate, wName, wDesc, wSym, wType, wIco);
end;
